# Upbit Open API
#
# ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
#
# OpenAPI spec version: 1.0.0
# Contact: ujhin942@gmail.com
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' NewOrder Class
#'
#' @field uuid 
#' @field side 
#' @field ord_type 
#' @field price 
#' @field avg_price 
#' @field state 
#' @field market 
#' @field created_at 
#' @field volume 
#' @field remaining_volume 
#' @field reserved_fee 
#' @field remaining_fee 
#' @field paid_fee 
#' @field locked 
#' @field executed_volume 
#' @field trades_count 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
NewOrder <- R6::R6Class(
  'NewOrder',
  public = list(
    `uuid` = NULL,
    `side` = NULL,
    `ord_type` = NULL,
    `price` = NULL,
    `avg_price` = NULL,
    `state` = NULL,
    `market` = NULL,
    `created_at` = NULL,
    `volume` = NULL,
    `remaining_volume` = NULL,
    `reserved_fee` = NULL,
    `remaining_fee` = NULL,
    `paid_fee` = NULL,
    `locked` = NULL,
    `executed_volume` = NULL,
    `trades_count` = NULL,
    initialize = function(`uuid`, `side`, `ord_type`, `price`, `avg_price`, `state`, `market`, `created_at`, `volume`, `remaining_volume`, `reserved_fee`, `remaining_fee`, `paid_fee`, `locked`, `executed_volume`, `trades_count`){
      if (!missing(`uuid`)) {
        stopifnot(is.character(`uuid`), length(`uuid`) == 1)
        self$`uuid` <- `uuid`
      }
      if (!missing(`side`)) {
        stopifnot(is.character(`side`), length(`side`) == 1)
        self$`side` <- `side`
      }
      if (!missing(`ord_type`)) {
        stopifnot(is.character(`ord_type`), length(`ord_type`) == 1)
        self$`ord_type` <- `ord_type`
      }
      if (!missing(`price`)) {
        stopifnot(is.character(`price`), length(`price`) == 1)
        self$`price` <- `price`
      }
      if (!missing(`avg_price`)) {
        stopifnot(is.character(`avg_price`), length(`avg_price`) == 1)
        self$`avg_price` <- `avg_price`
      }
      if (!missing(`state`)) {
        stopifnot(is.character(`state`), length(`state`) == 1)
        self$`state` <- `state`
      }
      if (!missing(`market`)) {
        stopifnot(is.character(`market`), length(`market`) == 1)
        self$`market` <- `market`
      }
      if (!missing(`created_at`)) {
        stopifnot(is.character(`created_at`), length(`created_at`) == 1)
        self$`created_at` <- `created_at`
      }
      if (!missing(`volume`)) {
        stopifnot(is.character(`volume`), length(`volume`) == 1)
        self$`volume` <- `volume`
      }
      if (!missing(`remaining_volume`)) {
        stopifnot(is.character(`remaining_volume`), length(`remaining_volume`) == 1)
        self$`remaining_volume` <- `remaining_volume`
      }
      if (!missing(`reserved_fee`)) {
        stopifnot(is.character(`reserved_fee`), length(`reserved_fee`) == 1)
        self$`reserved_fee` <- `reserved_fee`
      }
      if (!missing(`remaining_fee`)) {
        stopifnot(is.character(`remaining_fee`), length(`remaining_fee`) == 1)
        self$`remaining_fee` <- `remaining_fee`
      }
      if (!missing(`paid_fee`)) {
        stopifnot(is.character(`paid_fee`), length(`paid_fee`) == 1)
        self$`paid_fee` <- `paid_fee`
      }
      if (!missing(`locked`)) {
        stopifnot(is.character(`locked`), length(`locked`) == 1)
        self$`locked` <- `locked`
      }
      if (!missing(`executed_volume`)) {
        stopifnot(is.character(`executed_volume`), length(`executed_volume`) == 1)
        self$`executed_volume` <- `executed_volume`
      }
      if (!missing(`trades_count`)) {
        self$`trades_count` <- `trades_count`
      }
    },
    toJSON = function() {
      NewOrderObject <- list()
      if (!is.null(self$`uuid`)) {
        NewOrderObject[['uuid']] <- self$`uuid`
      }
      if (!is.null(self$`side`)) {
        NewOrderObject[['side']] <- self$`side`
      }
      if (!is.null(self$`ord_type`)) {
        NewOrderObject[['ord_type']] <- self$`ord_type`
      }
      if (!is.null(self$`price`)) {
        NewOrderObject[['price']] <- self$`price`
      }
      if (!is.null(self$`avg_price`)) {
        NewOrderObject[['avg_price']] <- self$`avg_price`
      }
      if (!is.null(self$`state`)) {
        NewOrderObject[['state']] <- self$`state`
      }
      if (!is.null(self$`market`)) {
        NewOrderObject[['market']] <- self$`market`
      }
      if (!is.null(self$`created_at`)) {
        NewOrderObject[['created_at']] <- self$`created_at`
      }
      if (!is.null(self$`volume`)) {
        NewOrderObject[['volume']] <- self$`volume`
      }
      if (!is.null(self$`remaining_volume`)) {
        NewOrderObject[['remaining_volume']] <- self$`remaining_volume`
      }
      if (!is.null(self$`reserved_fee`)) {
        NewOrderObject[['reserved_fee']] <- self$`reserved_fee`
      }
      if (!is.null(self$`remaining_fee`)) {
        NewOrderObject[['remaining_fee']] <- self$`remaining_fee`
      }
      if (!is.null(self$`paid_fee`)) {
        NewOrderObject[['paid_fee']] <- self$`paid_fee`
      }
      if (!is.null(self$`locked`)) {
        NewOrderObject[['locked']] <- self$`locked`
      }
      if (!is.null(self$`executed_volume`)) {
        NewOrderObject[['executed_volume']] <- self$`executed_volume`
      }
      if (!is.null(self$`trades_count`)) {
        NewOrderObject[['trades_count']] <- self$`trades_count`
      }

      NewOrderObject
    },
    fromJSON = function(NewOrderJson) {
      NewOrderObject <- jsonlite::fromJSON(NewOrderJson)
      if (!is.null(NewOrderObject$`uuid`)) {
        self$`uuid` <- NewOrderObject$`uuid`
      }
      if (!is.null(NewOrderObject$`side`)) {
        self$`side` <- NewOrderObject$`side`
      }
      if (!is.null(NewOrderObject$`ord_type`)) {
        self$`ord_type` <- NewOrderObject$`ord_type`
      }
      if (!is.null(NewOrderObject$`price`)) {
        self$`price` <- NewOrderObject$`price`
      }
      if (!is.null(NewOrderObject$`avg_price`)) {
        self$`avg_price` <- NewOrderObject$`avg_price`
      }
      if (!is.null(NewOrderObject$`state`)) {
        self$`state` <- NewOrderObject$`state`
      }
      if (!is.null(NewOrderObject$`market`)) {
        self$`market` <- NewOrderObject$`market`
      }
      if (!is.null(NewOrderObject$`created_at`)) {
        self$`created_at` <- NewOrderObject$`created_at`
      }
      if (!is.null(NewOrderObject$`volume`)) {
        self$`volume` <- NewOrderObject$`volume`
      }
      if (!is.null(NewOrderObject$`remaining_volume`)) {
        self$`remaining_volume` <- NewOrderObject$`remaining_volume`
      }
      if (!is.null(NewOrderObject$`reserved_fee`)) {
        self$`reserved_fee` <- NewOrderObject$`reserved_fee`
      }
      if (!is.null(NewOrderObject$`remaining_fee`)) {
        self$`remaining_fee` <- NewOrderObject$`remaining_fee`
      }
      if (!is.null(NewOrderObject$`paid_fee`)) {
        self$`paid_fee` <- NewOrderObject$`paid_fee`
      }
      if (!is.null(NewOrderObject$`locked`)) {
        self$`locked` <- NewOrderObject$`locked`
      }
      if (!is.null(NewOrderObject$`executed_volume`)) {
        self$`executed_volume` <- NewOrderObject$`executed_volume`
      }
      if (!is.null(NewOrderObject$`trades_count`)) {
        self$`trades_count` <- NewOrderObject$`trades_count`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "uuid": %s,
           "side": %s,
           "ord_type": %s,
           "price": %s,
           "avg_price": %s,
           "state": %s,
           "market": %s,
           "created_at": %s,
           "volume": %s,
           "remaining_volume": %s,
           "reserved_fee": %s,
           "remaining_fee": %s,
           "paid_fee": %s,
           "locked": %s,
           "executed_volume": %s,
           "trades_count": %s
        }',
        self$`uuid`,
        self$`side`,
        self$`ord_type`,
        self$`price`,
        self$`avg_price`,
        self$`state`,
        self$`market`,
        self$`created_at`,
        self$`volume`,
        self$`remaining_volume`,
        self$`reserved_fee`,
        self$`remaining_fee`,
        self$`paid_fee`,
        self$`locked`,
        self$`executed_volume`,
        self$`trades_count`
      )
    },
    fromJSONString = function(NewOrderJson) {
      NewOrderObject <- jsonlite::fromJSON(NewOrderJson)
      self$`uuid` <- NewOrderObject$`uuid`
      self$`side` <- NewOrderObject$`side`
      self$`ord_type` <- NewOrderObject$`ord_type`
      self$`price` <- NewOrderObject$`price`
      self$`avg_price` <- NewOrderObject$`avg_price`
      self$`state` <- NewOrderObject$`state`
      self$`market` <- NewOrderObject$`market`
      self$`created_at` <- NewOrderObject$`created_at`
      self$`volume` <- NewOrderObject$`volume`
      self$`remaining_volume` <- NewOrderObject$`remaining_volume`
      self$`reserved_fee` <- NewOrderObject$`reserved_fee`
      self$`remaining_fee` <- NewOrderObject$`remaining_fee`
      self$`paid_fee` <- NewOrderObject$`paid_fee`
      self$`locked` <- NewOrderObject$`locked`
      self$`executed_volume` <- NewOrderObject$`executed_volume`
      self$`trades_count` <- NewOrderObject$`trades_count`
    }
  )
)
